<template>
  <div>
    <base-container>
      <base-spacing y="2">
        <base-typography elem-type="h1" font-size="2rem"
          >Shopping Cart</base-typography
        >
      </base-spacing>
      <div :class="$style.cartPageWrapper">
        <section :class="$style.pageWrapper">
          <header :class="$style.header">
            <base-typography elem-type="h4" font-size="1.4rem"
              >My Bag</base-typography
            >
          </header>
          <hr :class="$style.seperatorLine" />
          <base-loading v-if="requestCardPendingGetter"></base-loading>
          <added-products-list v-else></added-products-list>
        </section>

        <base-spacing left="3" :class="$style.pageWrapper">
          <section>
            <header :class="$style.header">
              <base-typography elem-type="h4" font-size="1.4rem"
                >You might also likes</base-typography
              >
              <base-typography elem-type="p" type="light">
                #of products: {{ similarProductsGetter }}</base-typography
              >
            </header>
            <hr :class="$style.seperatorLine" />
            <base-loading v-if="requestCardPendingGetter"></base-loading>
            <related-products-list
              v-show="!requestCardPendingGetter"
            ></related-products-list>
          </section>
        </base-spacing>
      </div>
      <div :class="$style.checkoutWrapper">
        <base-spacing y="2">
          <base-typography elem-type="h1" font-size="2rem"
            >Checkout</base-typography
          >
          <hr :class="$style.seperatorLine" />
          <base-loading v-if="requestCardPendingGetter"></base-loading>
          <section v-else :class="$style.checkoutDetailsWrapper">
            <div :class="$style.infoWrapper">
              <div>
                <base-typography
                  elem-type="p"
                  font-size="1.2rem"
                  type="bold"
                  color="secondary"
                  >Total Price</base-typography
                >
                <base-typography elem-type="p" type="bold" font-size="1.2rem">
                  {{
                    totalPriceGetter ? totalPriceGetter : "0" | currencyFilter
                  }}
                </base-typography>
              </div>

              <div :class="$style.totalQuantityWrapper">
                <base-typography
                  elem-type="p"
                  font-size="1.2rem"
                  type="bold"
                  color="secondary"
                  >Total Quantity</base-typography
                >
                <base-typography elem-type="p" type="bold" font-size="1.2rem">
                  {{ totalQuantityGetter }}
                </base-typography>
              </div>
            </div>

            <div :class="$style.checkoutActions">
              <base-spacing x="0.4">
                <base-button theme="outline-primary" @click="removeAllHandler">
                  Remove All
                </base-button>
              </base-spacing>
              <base-button theme="primary">
                <base-typography elem-type="p" type="bold" font-size="0.8rem">
                  Checkout ({{
                    totalPriceGetter ? totalPriceGetter : "0" | currencyFilter
                  }})
                </base-typography>
              </base-button>
            </div>
          </section>
        </base-spacing>
      </div>
    </base-container>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
// vuex
import { createNamespacedHelpers } from "vuex";
import ActionTypes from "@/store/modules/cart/action-types";
import MutationTypes from "@/store/modules/cart/mutation-types";

const { mapActions, mapGetters, mapMutations } = createNamespacedHelpers(
  "cart"
);
// components

import BaseContainer from "@/components/base/BaseGrid/container.vue";
import BaseLoading from "@/components/base/BaseLoading/index.vue";
import BaseButton from "@/components/base/BaseButton/index.vue";
import BaseSpacing from "@/components/base/BaseSpacing/index.vue";
import BaseTypography from "@/components/base/BaseTypography/index.vue";

// logical components
import AddedProductsList from "@/components/cart/AddedProductsList/index.vue";
import RelatedProductsList from "@/components/cart/RelatedProductsList/index.vue";

// filters

import currencyFilter from "@/filters/price";

export default Vue.extend({
  name: "Home",
  components: {
    BaseLoading,
    BaseContainer,
    BaseSpacing,
    BaseTypography,
    AddedProductsList,
    RelatedProductsList,
    BaseButton
  },
  filters: {
    currencyFilter
  },
  methods: {
    ...mapActions({
      getCartData: ActionTypes.GET_CARD_DETAILS
    }),
    ...mapMutations([MutationTypes.REMOVE_ALL_ITEMS_IN_CART]),
    removeAllHandler: function() {
      this[MutationTypes.REMOVE_ALL_ITEMS_IN_CART]();
    }
  },
  computed: {
    ...mapGetters([
      "totalQuantityGetter",
      "totalPriceGetter",
      "similarProductsGetter",
      "requestCardPendingGetter"
    ])
  },
  mounted: function() {
    this.getCartData();
  }
});
</script>

<style module lang="scss">
.cartPageWrapper {
  composes: display--flex;
}
.seperatorLine {
  margin: 1rem 0 1.6rem 0;
}
.pageWrapper {
  composes: width-50-percentage;
}
.checkoutDetailsWrapper {
  composes: display--flex;
  composes: align-items--center;
  composes: justify-content--space-between;
}
.header {
  composes: display--flex;
  composes: align-items--center;
  composes: justify-content--space-between;
}
.totalQuantityWrapper {
  margin: 0 2rem;
}

.checkoutActions {
  composes: display--flex;
}
.infoWrapper {
  composes: display--flex;
}
@media screen and (max-width: $device-size--mobile-large) {
  .cartPageWrapper {
    flex-direction: column;
  }
  .pageWrapper {
    width: 100%;
    margin-left: 0 !important;
    margin-top: 30px;
  }
  .wrapper {
    flex-direction: column;
    max-width: 100%;
    > div:first-child {
      margin-right: 0 !important;
      margin-left: 0 !important;
      margin-bottom: 15px;
    }
  }
  .checkoutActions {
    flex-direction: column;
    > div {
      margin-bottom: 10px;
    }
  }
}
</style>
